--[[
Copyright 2012 João Cardoso
PetTracker is distributed under the terms of the GNU General Public License (Version 3).
As a special exception, the copyright holders of this addon do not give permission to
redistribute and/or modify it.

This addon is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the addon. If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.

This file is part of PetTracker.
--]]

local ADDON, Addon = ...
local NewClass = LibStub('Poncho-1.0')
_G[ADDON] = Addon


--[[ API ]]--

function Addon:NewClass(type, name, ...)
	return self:NewModule(name, NewClass(type, ADDON .. name, nil, ...))
end

function Addon:NewModule(name, object)
	object = object or {}
	self[name] = object
	return object
end


--[[ Startup ]]--

function Addon:StartupModules()
	for name, module in pairs(Addon) do
		if type(module) == 'table' and module.Startup then
			module:Startup()
			module.Startup = nil
		end
	end
end

local Frame = CreateFrame('Frame')
Frame:RegisterEvent('VARIABLES_LOADED')
Frame:SetScript('OnEvent', Addon.StartupModules)